"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var tslib_1=require("tslib"),HTTP=require("http"),fs=require("fs-extra"),WebServerDto=require("./WebServerDto"),LarkBuffer_1=require("../Utils/LarkBuffer"),LarkResponse_1=require("./LarkResponse"),LarkError_1=require("../Log/LarkError"),LarkRequest_1=require("./LarkRequest"),LarkLogger_1=require("../Log/LarkLogger"),ServerStaticController_1=require("./Controller/ServerStaticController"),HTTP_STATUS_1=require("../Http/HTTP_STATUS"),URL=require("url"),QueryString=require("querystring");exports.ERROR_UNSUPPORT_METHOD={message:"请求行中指定的请求方法不能被用于请求相应的资源。该响应必须返回一个Allow 头信息用以表示出当前资源能够接受的请求方法的列表。",code:1534906424292},exports.ERROR_ROUTER_NOT_FOUND={message:"请求失败，请求所希望得到的资源未被在服务器上发现。没有信息能够告诉用户这个状况到底是暂时的还是永久的。假如服务器知道情况的话，应当使用410状态码来告知旧资源因为某些内部的配置机制问题，已经永久的不可用，而且没有任何可以跳转的地址。404这个状态码被广泛应用于当服务器不想揭示到底为何请求被拒绝或者没有其他适合的响应可用的情况下。出现这个错误的最有可能的原因是服务器端没有这个页面。",code:1534906617911},exports.ERROR_UNKNOW={message:"WebServer未能预知的异常",code:1534906822369};var logger=new LarkLogger_1.LarkLogger("WebServer"),WebServer=function(){function e(){this.httpServer=null,this.httpsServer=null,this.CONFIG=WebServerDto,this.controllerList=[]}return e.prototype.initCONFIG=function(){if(fs.existsSync("./config/web.json")){var e=fs.readJSONSync("config/web.json");this.CONFIG=Object.assign(this.CONFIG,e)}},e.prototype.controllerParser=function(u,l,_){return tslib_1.__awaiter(this,void 0,void 0,function(){var r,t,o,s,n,i,a;return tslib_1.__generator(this,function(e){switch(e.label){case 0:return r=l.method.toLowerCase(),t=URL.parse(l.url),o=QueryString.parse(t.query),s=l.headers.cookie,n=l.headers,i=new u,logger.info({method:r}),[4,i[r](l,{url:t,method:r,query:o,params:void 0,cookie:s,headers:n,uri:_})];case 1:return void 0===(a=e.sent())&&(a=new LarkResponse_1.LarkResponse),[2,a]}})})},e.prototype.controllerRouter=function(R){return tslib_1.__awaiter(this,void 0,void 0,function(){var r,t,o,s,n,i,a,u,l,_,c;return tslib_1.__generator(this,function(e){switch(e.label){case 0:r=R.headers.host.split(":")[0],t=R.url.split("?")[0],o=0,s=this.controllerList,e.label=1;case 1:return o<s.length?(n=s[o],i=new n,r!==i.hostname&&null!==i.hostname?[3,4]:(logger.log("hostname.hit",{hostname:r}),a=null,a=void 0===n.URI?i.uri:n.URI,u="string"==typeof a&&a===t,l=a instanceof RegExp&&a.test(t),(_=u||l)?(logger.log("uriHit",a,t),(c="function"==typeof i[R.method.toLowerCase()])?[4,this.controllerParser(n,R,t)]:[3,3]):[3,4])):[3,5];case 2:return[2,e.sent()];case 3:throw new LarkError_1.LarkError(exports.ERROR_UNSUPPORT_METHOD.message,{method:R.method.toLowerCase(),uriStringHit:u,hasController:c,uriRegExpHit:l,uriHit:_,userURI:t,controllerURI:a},exports.ERROR_UNSUPPORT_METHOD.code);case 4:return o++,[3,1];case 5:throw new LarkError_1.LarkError(exports.ERROR_ROUTER_NOT_FOUND.message,null,exports.ERROR_ROUTER_NOT_FOUND.code)}})})},e.prototype.router=function(i,a){return tslib_1.__awaiter(this,void 0,void 0,function(){var r,t,o,s,n;return tslib_1.__generator(this,function(e){switch(e.label){case 0:logger.log(i.headers,i.method,i.httpVersion,i.url),o=t=r=null,e.label=1;case 1:return e.trys.push([1,3,,4]),[4,this.controllerRouter(i)];case 2:return s=e.sent(),logger.log({larkResponse:s}),t=s.header,r=s.getData(),o=s.status,[3,4];case 3:if(n=e.sent(),logger.log(n),o=500,t={"Content-Type":"application/json"},r=Buffer.from(JSON.stringify({ok:!1,message:"服务器异常",error:n})),n instanceof LarkError_1.LarkError)switch(n.code){case exports.ERROR_ROUTER_NOT_FOUND.code:o=HTTP_STATUS_1.HTTP_STATUS.NOT_FOUND,r=Buffer.from(JSON.stringify({ok:!1,message:exports.ERROR_ROUTER_NOT_FOUND.message,error:n}));break;case exports.ERROR_UNSUPPORT_METHOD.code:o=HTTP_STATUS_1.HTTP_STATUS.METHOD_NOT_ALLOWED,r=Buffer.from(JSON.stringify({ok:!1,message:exports.ERROR_UNSUPPORT_METHOD.message,error:n})),t.Allow=n.data.method;break;case LarkBuffer_1.ERROR_MAX_BODY_SIZE_LIMIT.code:o=HTTP_STATUS_1.HTTP_STATUS.REQUEST_ENTITY_TOO_LARGE,r=Buffer.from(JSON.stringify({ok:!1,message:LarkBuffer_1.ERROR_MAX_BODY_SIZE_LIMIT.message,error:n}));break;default:r=Buffer.from(JSON.stringify({ok:!1,error:n}))}return[3,4];case 4:return LarkRequest_1.LarkRequest.hasAcceptEncodingGZIP(i.headers)&&(r=LarkBuffer_1.LarkBuffer.GZIP(r),t["Content-Encoding"]="gzip"),a.writeHead(o,t),a.end(r),[2]}})})},e.prototype.startup=function(){return tslib_1.__awaiter(this,void 0,void 0,function(){return tslib_1.__generator(this,function(e){switch(e.label){case 0:return this.controllerList.push(ServerStaticController_1.ServerStaticController),[4,this.initCONFIG()];case 1:return e.sent(),[4,this.listenHTTP()];case 2:return e.sent(),[2]}})})},e.prototype.listenHTTP=function(){return tslib_1.__awaiter(this,void 0,void 0,function(){var o=this;return tslib_1.__generator(this,function(e){return null===this.CONFIG.PORT?[2]:[2,new Promise(function(r,t){o.httpServer=HTTP.createServer(function(e,r){o.router(e,r)}),o.httpServer.listen(o.CONFIG.PORT,function(e){e?t(e):(logger.log("listen http","http://127.0.0.1:"+o.CONFIG.PORT),r())})})]})})},e.prototype.addAction=function(e){return this.addController(e),this},e.prototype.addController=function(e){return this.controllerList.push(e),this},e}();exports.WebServer=WebServer;